<?php
/*------------------------------------------------------------------------
# "Sparky Framework" - Joomla Template Framework
# Copyright (C) 2016 HotThemes. All Rights Reserved.
# License: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
# Author: HotThemes
# Website: http://www.hotjoomlatemplates.com
-------------------------------------------------------------------------*/
defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Helper\AuthenticationHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;

/** @var Joomla\CMS\Document\HtmlDocument $this */

$extraButtons     = AuthenticationHelper::getLoginButtons('form-login');
$app              = Factory::getApplication();
$wa               = $this->getWebAssetManager();

if(!defined('DS')) {
    define("DS", DIRECTORY_SEPARATOR);
}
$doc = JFactory::getDocument();
$template_path = $this->baseurl.'/templates/'.$this->template;
$media_path = $this->baseurl.'/media/templates/site/'.$this->template;
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<?php
// Google fonts
$google_obj = $this->params->get("googleUrl","{}");
if ($google_obj != "{}") { ?>
<link rel="preconnect" href="https://fonts.gstatic.com">
    <?php
    $google_href = "https://fonts.googleapis.com/css2?family=";
    $google_obj = json_decode($google_obj, true);
    $separator = "";
    $italic = false;
    $italic_only = false;

    foreach($google_obj as $key => $g_o) {

        // get font name
        $google_href = $google_href.$separator.str_replace(" ", "+", $key).":";

        // check if it contains italic
        foreach($g_o["variant"] as $key2 => $variant) {
            if (strpos($variant, "italic") !== false) {
                $italic = true;
            }
        }

        // check if italic is only variant
        if ( $italic ) {
            foreach($g_o["variant"] as $key3 => $variant) {
                if (strpos($variant, "italic") !== false) {
                    $italic_only = true;
                } else {
                    break;
                }
            }
        }

        // add italic to the url or not
        if ( $italic ) {
            $google_href .= "ital,wght@";
        } else {
            $google_href .= "wght@";
        }
        
        // Add font variants to the url

        // only regular
        if ( !$italic ) {
            foreach($g_o["variant"] as $variant) {
                if ($variant == "regular") {
                    $variant = "400";
                }
                $google_href .= $variant.";";
            }
            $google_href = substr($google_href, 0, -1);
        }

        // only italic
        if ( $italic_only ) {
            foreach($g_o["variant"] as $variant) {
                $variant = str_replace("italic", "", $variant);
                if ( $variant == "" ) {
                    $variant = "400";
                }
                $google_href .= "1,".$variant.";";
            }
            $google_href = substr($google_href, 0, -1);
        }

        // both regular and italic
        if ( !$italic_only && $italic ) {
            // add regular
            foreach($g_o["variant"] as $variant) {
                if (strpos($variant, "italic") === false) {
                    if ($variant == "regular") {
                        $variant = "400";
                    }
                    $google_href .= "0,".$variant.";";
                }
            }
            // add italic
            foreach($g_o["variant"] as $variant) {
                if (strpos($variant, "italic") !== false) {
                    $variant = str_replace("italic", "", $variant);
                    if ( $variant == "" ) {
                        $variant = "400";
                    }
                    $google_href .= "1,".$variant.";";
                }
            }
            $google_href = substr($google_href, 0, -1);
        }


        // if multiple fonts, add separator
        $separator = "&family=";

        // reset italic
        $italic = false;
        $italic_only = false;

    }

    $google_href .= "&display=swap";

    $doc->addStyleSheet($google_href);
}
    
// Get Sparky parameters
require(dirname(__FILE__).DS.'library'.DS.'sparky_parameters.php');
    
// READ MENU CONFIGURATION ///////////////////////////////////////////////////////

$LoadMENU_Acc = false;
$LoadMENU_Navh = false;
$LoadMENU_Navv = false;
$LoadMENU_Offcanvas = false;
$LoadMENU_Mega = false;

global $mnucfg;
$mnucfg = array();

$mnu_load = json_decode($this->params->get("mnucfg", "[]"));
foreach($mnu_load as $mnu){
    
    $mnu_name = $mnu->name;
    $mnu_val  = $mnu->type;

    if ($mnu_val == "acc" || strpos($mnu_val, "acc")) {
        $LoadMENU_Acc = true;
        $doc->addScript('media/templates/site/sparky_framework/js/jquery-ui.min.js');
    } else if($mnu_val == "navh" || strpos($mnu_val, "navh")) {
        $LoadMENU_Navh = true;
    } else if($mnu_val == "navv" || strpos($mnu_val, "navv")) {
        $LoadMENU_Navv = true;
    } else if($mnu_val == "offcanvas" || strpos($mnu_val, "offcanvas")) {
        $LoadMENU_Offcanvas = true;
    } else if($mnu_val == "mega" || strpos($mnu_val, "mega")) {
        $LoadMENU_Mega = true;
        $doc->addScript('media/templates/site/sparky_framework/js/jquery-ui.min.js');
    }

    $mnucfg[$mnu_name] = array();
    $mnucfg[$mnu_name]['type'] = $mnu_val;
    
    foreach ($mnu->config as $prop => $value) {
        $mnucfg[$mnu_name][$prop] = $value;
    }
}       
// now we have, in example: echo $mnucfg['footer1']['text_color'];

// GRID LAYOUT ///////////////////////////////////////////////////////
    
//$gridRow[0] - Name
//$gridRow[1] - Class
//$gridRow[2] - ModulePos1,ModulePos2...
//$gridRow[3] - Holds content flag: true/false
//$mposition[0] - position name 
//$mposition[1] - number of grid cells occupied by position
//$mposition[2] - number of empty cells left of module 

$module_grid = json_decode($layoutdesign);
require(dirname(__FILE__).DS.'library'.DS.'sparky_grid.php');

// normalize.css
$doc->addStyleSheet($this->baseurl . '/media/templates/site/sparky_framework/css/normalize.css');

if ($loadBootstrap) {
    JHtml::_('jquery.framework');
    JHtml::_('bootstrap.framework');
    $doc->addStyleSheet($this->baseurl . '/media/vendor/bootstrap/css/bootstrap.min.css');
}

// add automatically generated CSS file
if ($exportedcssfile) {
    $doc->addStyleSheet($this->baseurl . '/media/templates/site/' . $this->template . '/css/' . $exportedcssfile);
}

// Live style switching (cookie based)
    
// check if in cookie
if (isset($_COOKIE['Style'])) {
    $templateStyle = $_COOKIE['Style'];
}

$templateStyleTest = "";

// check if in link
if (isset($_GET['style'])) {
    $templateStyleTest = $_GET['style']; 
}

if ($templateStyleTest) { 
    $templateStyle = $templateStyleTest;
    $Month = 2592000 + time(); 
    setcookie("Style", $templateStyle, $Month);
}

// Get custom.css if it's not empty
if (file_get_contents(JPATH_SITE . '/media/templates/site/' . $this->template . '/css/custom.css') != '') {
    $doc->addStyleSheet($this->baseurl .'/media/templates/site/' . $this->template . '/css/custom.css');
}
if ($this->direction == "rtl") {
    if (file_get_contents(JPATH_SITE.'/media/templates/site/' . $this->template . '/css/custom_rtl.css') != '') {
        $doc->addStyleSheet($this->baseurl .'/media/templates/site/' . $this->template . '/css/custom_rtl.css');
    }
}

// Get specific parameters for this style from /css/styles
if ($templateStyle) {

    if ($templateStyle != 1) {
        $doc->addStyleSheet( $this->baseurl . '/media/templates/site/' . $this->template . '/css/styles/style'.$templateStyle.'.css');
    }
    for ($i=1; $i<9; $i++) {
        if ($templateStyle == $i) {
            $templateStyleColors = $this->params->get("palette".$i);
        }
    }
    if (!$templateStyleColors) {
        $templateStyleColors = $this->params->get("sparkycolor1").",".$this->params->get("sparkycolor2").",".$this->params->get("sparkycolor3").",".$this->params->get("sparkycolor4").",".$this->params->get("sparkycolor5").",".$this->params->get("sparkycolor6");
    }
    $sparkycolor = explode(",", $templateStyleColors);

    $doc->addStyleDeclaration(":root {
  --sparkycolor1: ".$sparkycolor[0].";
  --sparkycolor2: ".$sparkycolor[1].";
  --sparkycolor3: ".$sparkycolor[2].";
  --sparkycolor4: ".$sparkycolor[3].";
  --sparkycolor5: ".$sparkycolor[4].";
  --sparkycolor6: ".$sparkycolor[5].";
}");
}

if ($favicon != -1) {
?>
<link href="<?php echo $media_path.DS.'images'.DS.'icons'.DS.$favicon; ?>" rel="shortcut icon" type="image/vnd.microsoft.icon" />
<?php }
if ($appleicon != -1) {
?>
<link href="<?php echo $media_path.DS.'images'.DS.'icons'.DS.$appleicon; ?>" rel="apple-touch-icon" />
<?php }
if ($androidicon != -1) {
?>
<link href="<?php echo $media_path.DS.'images'.DS.'icons'.DS.$androidicon; ?>" rel="icon" sizes="192x192" />
<?php } ?>

<jdoc:include type="head" />

<?php
// load custom header code
if($customhead) {
    echo "<!-- Custom header code -->\n";
    echo $customhead."\n";
}

// load jQuery UI
if ($loadJqueryUI) {
    $doc->addScript($this->baseurl . '/media/templates/site/sparky_framework/js/jquery-ui.min.js');
}

// add automatically generated JS file
if ($exportedjsfile) {
    $doc->addScript($this->baseurl . '/media/templates/site/' . $this->template . '/js/'.$exportedjsfile);
}

if($enableResponsiveMenu){ ?><script src="<?php echo $this->baseurl.'/media/templates/site/sparky_framework'; ?>/js/responsive-nav.min.js"></script>
<?php } ?>
</head>
<?php 
$menu = JFactory::getApplication()->getMenu();
$lang = JFactory::getLanguage();
if (isset($menu->getActive()->alias)) {
    $pageAlias = $menu->getActive()->alias;
} else {
    $pageAlias = "";
}
?>
<body style="background: transparent; color:#333;">
<div class="sparky_wrapper" style="max-width: 460px; margin: 15px auto; background: transparent;">
    <?php if ($app->get('offline_image')) : ?>
        <?php echo HTMLHelper::_('image', $app->get('offline_image'), "", [], false, 0); ?>
    <?php endif; ?>
    <br><br>
    <?php if ($app->get('display_offline_message', 1) == 1 && str_replace(' ', '', $app->get('offline_message')) != '') : ?>
        <p><?php echo $app->get('offline_message'); ?></p>
    <?php elseif ($app->get('display_offline_message', 1) == 2) : ?>
        <p><?php echo Text::_('JOFFLINE_MESSAGE'); ?></p>
    <?php endif; ?>
    <div class="login">
        <jdoc:include type="message" />
        <form action="<?php echo Route::_('index.php', true); ?>" method="post" id="form-login">
            <fieldset>
                <label for="username"><?php echo Text::_('JGLOBAL_USERNAME'); ?></label>
                <input name="username" class="form-control" id="username" type="text">
                <br>
                <label for="password"><?php echo Text::_('JGLOBAL_PASSWORD'); ?></label>
                <input name="password" class="form-control" id="password" type="password">

                <?php foreach ($extraButtons as $button) :
                    $dataAttributeKeys = array_filter(array_keys($button), function ($key) {
                        return substr($key, 0, 5) == 'data-';
                    });
                    ?>
                    <div class="mod-login__submit form-group">
                        <button type="button"
                                class="btn btn-secondary w-100 mt-4 <?php echo $button['class'] ?? '' ?>"
                        <?php foreach ($dataAttributeKeys as $key) : ?>
                            <?php echo $key ?>="<?php echo $button[$key] ?>"
                        <?php endforeach; ?>
                        <?php if ($button['onclick']) : ?>
                            onclick="<?php echo $button['onclick'] ?>"
                        <?php endif; ?>
                        title="<?php echo Text::_($button['label']) ?>"
                        id="<?php echo $button['id'] ?>"
                        >
                        <?php if (!empty($button['icon'])) : ?>
                            <span class="<?php echo $button['icon'] ?>"></span>
                        <?php elseif (!empty($button['image'])) : ?>
                            <?php echo $button['image']; ?>
                        <?php elseif (!empty($button['svg'])) : ?>
                            <?php echo $button['svg']; ?>
                        <?php endif; ?>
                        <?php echo Text::_($button['label']) ?>
                        </button>
                    </div>
                <?php endforeach; ?>
                <br>
                <button type="submit" name="Submit" class="btn btn-primary"><?php echo Text::_('JLOGIN'); ?></button>

                <input type="hidden" name="option" value="com_users">
                <input type="hidden" name="task" value="user.login">
                <input type="hidden" name="return" value="<?php echo base64_encode(Uri::base()); ?>">
                <?php echo HTMLHelper::_('form.token'); ?>
            </fieldset>
        </form>
    </div>
</div>
</body>
</html>